package de.yourwebs.cent;
import java.awt.BorderLayout;

import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JWindow;

/**
 * @CentSplash.java     19.03.2008
 * Copyright 2008-2011 yourwebs.de. All rights reserved
 * @author J&ouml;rg Czeschla
 *
 * This file is a part of Cent
 * Cent is free software; you can redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.

 * Cent is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License along with Cent;
 * if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
 */

/**
 * 
 * Stellt einen Splash-Screen in einem eigenen Thread bereit
 */
public class CentSplash extends JWindow {

	private static final long serialVersionUID = 1L;

	public CentSplash(String image, String text) {
		JPanel contentPane = new JPanel();
		contentPane.setLayout(new BorderLayout());
		ImageIcon icon = new ImageIcon(ClassLoader.getSystemResource(image));
		contentPane.add(new JLabel(icon, JLabel.CENTER), BorderLayout.CENTER);
		contentPane.add(new JLabel(text), BorderLayout.SOUTH);
		setContentPane(contentPane);
		setSize(icon.getIconWidth(), icon.getIconHeight());
		this.setLocationRelativeTo(null);
		this.setAlwaysOnTop(true);
		this.setVisible(true);
		this.showFor(Config.SPLASH_TIME);
	}

	public void showFor(int millis) {
		try {
			Thread.sleep(millis);
		} catch (InterruptedException e) {
		}
		setVisible(false);
	}
}
