package de.yourwebs.cent;
import java.util.Enumeration;
import java.util.Hashtable;

import javax.swing.JLabel;

/**
 * @SonderzeichenLabel.java     25.03.2008
 * Copyright 2008-2011 yourwebs.de. All rights reserved
 * @author J&ouml;rg Czeschla
 * stellt eine Tabelle mit den HTML- und numerischen Unicode-Entities bereit
 * 
 *
 * This file is a part of Cent
 * Cent is free software; you can redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.

 * Cent is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License along with Cent;
 * if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
 */

/**
 * 
 * 
 */
public class SonderzeichenLabel extends JLabel {

	private static final long serialVersionUID = 1L;
	Config config = Config.getConfig();

	public SonderzeichenLabel() {
		writeTable();
	}

	/**
	 * schreibt eine 9-spaltige Tabelle mit Sonderzeichen und deren HTML- und numerischen Unicode-Entities 
	 */
	private void writeTable() {
		Hashtable<Character,String> ht = config.getLib();
		Enumeration<Character> keys = ht.keys();
		String s = "<html><table cellpadding=\"10\">";
		int i = 1;
		while (keys.hasMoreElements()) {
			if (i % 3 == 1)
				if (i % 2 == 1)
					s += "<tr bgcolor=\"#E6E6E6\"><td align=\"left\">";
				else
					s += "<tr><td align=\"left\">";
			if (i % 3 != 1)
				s += "<td align=\"left\">";
			Object o = keys.nextElement();
			String htmlEntity = new String((String) ht.get(o));
			htmlEntity = "&amp;" + htmlEntity.substring(1);
			String unicodeEntity = "&amp;#"
					+ new Integer((int) ((Character) o).charValue()).toString()
					+ ";";

			// HTML-Klammer wird in HTML-Kontext nicht angezeigt, deshalb als Entity ausgeben
			if(o.equals('\u003c')){
				o = "&lt";
			}
			s += o;
			s += "</td>";
			s += "<td align=\"left\">" + htmlEntity + "</td>";
			s += "<td align=\"left\" width=\"200\">" + unicodeEntity;
			if (i % 3 == 0)
				s += "</td></tr>";
			else
				s += "</td>";
			i++;
		}
		s += "</table></html>";
		this.setText(s);
	}
}
