/**
 * @CentPanel.java     08.09.2008
 * Copyright 2008-2011 yourwebs.de. All rights reserved
 * @author J&ouml;rg Czeschla
 *
 * This file is a part of Cent
 * Cent is free software; you can redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.

 * Cent is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License along with Cent;
 * if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
 */
package de.yourwebs.cent.components;

import java.awt.Component;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.JPanel;

/**
 * stellt die Elternklasse fuer die Panels des Option-Dialogs bereit
 * Das Panel definiert ein GridBagLayout und definiert die Factory-Methode add()
 * 
 */
public class CentPanel extends JPanel {

	private static final long serialVersionUID = 1L;
	protected GridBagLayout layout;
	protected GridBagConstraints constraints;
	protected Insets insets;
	
	public CentPanel() {
		super();
		
		layout = new GridBagLayout();
		this.setLayout(layout);
		constraints = new GridBagConstraints();
		insets = constraints.insets;
		insets.set(5, 5, 5, 5);
		constraints.anchor = GridBagConstraints.NORTHWEST;
		constraints.fill = GridBagConstraints.BOTH;
	}

	protected void add(Component c, GridBagConstraints constraints, int x, int y,
			int w, int h, JPanel p) {
		constraints.gridx = x;
		constraints.gridy = y;
		constraints.gridwidth = w;
		constraints.gridheight = h;
		p.add(c, constraints);
	}

}