/**
 * @CentToggleButton.java     21.03.2008
 * Copyright 2008-2011 yourwebs.de. All rights reserved
 * @author J&ouml;rg Czeschla
 *
 * This file is a part of Cent
 * Cent is free software; you can redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.

 * Cent is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License along with Cent;
 * if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
 */
package de.yourwebs.cent.components;

import java.awt.Color;
import java.awt.Dimension;

import javax.swing.ImageIcon;
import javax.swing.JToggleButton;
import javax.swing.border.LineBorder;

/**
 * JToggleButton mit zwei Zustand-Icons und schwarzer LineBorder
 * 
 */
public class CentToggleButton extends JToggleButton {

	private static final long serialVersionUID = 1L;

	public CentToggleButton(ImageIcon deselected, ImageIcon selected) {
		this(deselected, selected, false);		
	}
	
	public CentToggleButton(ImageIcon deselected, ImageIcon selected, boolean isSelected) {
		super(deselected, isSelected);
		this.setSelectedIcon(selected);
		this.setBorder(new LineBorder(Color.BLACK, 1));
		this.setPreferredSize(new Dimension(32, 32));
	}
}
