package de.yourwebs.cent.dialogs;

/**
 * Programmname: Cent
 * @link http://www.yourwebs.de
 * @author Joerg Czeschla Copyright 2008-2011 - YOURWEBS - Joerg Czeschla mail:
 *         yourwebs@gmx.de
 *         Stellt den About-Dialog der Anwendung bereit
 *         Er besteht aus einer JTabbedPane mit einem About-Panel und einem Panel, das die GPL darstellt
 */
/*
 * This file is a part of Cent. Cent is free software; you can redistribute
 * it and/or modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 * 
 * Cent is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * TexTEn; if not, write to the Free Software Foundation, Inc., 59 Temple Place,
 * Suite 330, Boston, MA 02111-1307, USA.
 */

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.desktop.AboutEvent;
import java.awt.desktop.AboutHandler;
import java.io.IOException;
import java.net.URL;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JEditorPane;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.SwingConstants;

import de.yourwebs.cent.CentGUI;
import de.yourwebs.cent.Config;

public class AboutDialog extends JDialog implements ActionListener {

	private static final long serialVersionUID = 1L;

	private JTabbedPane tabbedPane;

	private JPanel aboutPanel;

	private JButton okButt;

	CentGUI parent;

	public AboutDialog(JFrame parent) {
		super(parent, Config.APP_NAME, true);
		this.parent = (CentGUI) parent;
		initComponents();
		this.setTitle(Config.APP_NAME + " " + Config.APP_VERSION);
		this.setSize(570, 320);
		this.setLocationRelativeTo(parent);
		this.setVisible(true);
	}

	public void initComponents() {

		okButt = new JButton("ok");
		okButt.addActionListener(this);
		JPanel buttonPanel = new JPanel();
		buttonPanel.add(okButt);

		// About
		ImageIcon icon = new ImageIcon(ClassLoader
				.getSystemResource(Config.IMG_VERZ + "cent_200_javabeginners.png"));
		JLabel topTextLabel = new JLabel(icon, SwingConstants.LEFT);

		String hauptText = "<html><p align='center' bgcolor='#ffffff'>"
				+ "<font size='4' color='#ff0000'>" + Config.APP_NAME + "</font>"
				+ "<font size='4' color='#000000'> "
				+ "ist ein Programm zur Konvertierung<br>von Sonderzeichen zu Entities<br>in Markup- und anderen textbasierten Dateien.</font>"
				+ "<br><br><font size='2'>" + Config.COPYRIGHT
				+ "<br>" + Config.APP_NAME + " " + Config.APP_VERSION
				+ ",  build:" + Config.BUILD + "</font></html>";
		JLabel hauptLabel = new JLabel(hauptText, SwingConstants.CENTER);

		aboutPanel = new JPanel();
		aboutPanel.setBackground(Color.WHITE);
		aboutPanel.add(topTextLabel, BorderLayout.NORTH);
		aboutPanel.add(hauptLabel, BorderLayout.CENTER);

		URL url = this.getClass().getClassLoader().getResource(
				"lizenz/lizenz.htm");

		// Lizenz
		JEditorPane pane = null;
		try {
			pane = new JEditorPane(url);
		} catch (IOException e) {
			e.printStackTrace();
		}

		tabbedPane = new JTabbedPane();
		JScrollPane sp = new JScrollPane(pane,
				JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
				JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);

		tabbedPane.add(aboutPanel, "\u00FCber " + Config.APP_NAME);
		tabbedPane.add(sp, "Lizenz");

		this.add(tabbedPane, BorderLayout.CENTER);
		this.add(buttonPanel, BorderLayout.SOUTH);
	}

	public void actionPerformed(ActionEvent e) {
		this.dispose();
	}
}
