package de.yourwebs.cent.dialogs.options;

import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Properties;

import javax.swing.JCheckBox;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.border.EtchedBorder;

import de.yourwebs.cent.Config;
import de.yourwebs.cent.components.CentPanel;

/**
 * @ErsetzenPanel.java     08.09.2008
 * Copyright 2008-2011 yourwebs.de. All rights reserved
 * @author J&ouml;rg Czeschla
 *
 * This file is a part of Cent
 * Cent is free software; you can redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.

 * Cent is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License along with Cent;
 * if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
 */

/**
 * stellt das JPanel 'ersetzen' im Optionen-Dialog bereit
 * 
 */
public class ErsetzenPanel extends CentPanel implements ActionListener {

	private static final long serialVersionUID = 1L;

	private ExchangeTable exchangeTable;

	private VerticalButtonPanel verticalButtonPanel;

	private JCheckBox aktivCB, startCB;

	private Properties properties = Config.getConfig().getProperties();

	private Config config = Config.getConfig();

	public ErsetzenPanel() {

		exchangeTable = new ExchangeTable();
		verticalButtonPanel = new VerticalButtonPanel(this);
		verticalButtonPanel.setBorder(new EtchedBorder());

		JScrollPane scrollPane = new JScrollPane(exchangeTable);
		scrollPane.setPreferredSize(new Dimension(300, 300));

		aktivCB = new JCheckBox("aktivieren", new Boolean(properties
				.getProperty("ACTIVATE_TABLE")));
		aktivCB.setToolTipText("Ersetzen aktivieren");
		aktivCB.addActionListener(this);
		startCB = new JCheckBox("automatisch", new Boolean(properties
				.getProperty("USE_TABLE_WHILE_STARTING")));
		startCB.setToolTipText("Ersetzen wenn Datei geladen wird");
		startCB.addActionListener(this);
		JPanel cbPanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
		cbPanel.add(aktivCB);
		cbPanel.add(startCB);

		add(scrollPane, constraints, 0, 0, 1, 1, this);
		add(verticalButtonPanel, constraints, 1, 0, 1, 1, this);
		constraints.weighty = 0.9;
		add(cbPanel, constraints, 0, 1, 2, 1, this);
	} // Konstruktor

	/**
	 * 
	 * @return die JTable des ErsetzenPanels
	 */
	public ExchangeTable getErsetzenTabelle() {
		return exchangeTable;
	}

	public void actionPerformed(ActionEvent e) {
		// aktuelle Zeile ermitteln
		int row = exchangeTable.getCursorPosition()[0];

		// die Zeile, die den Focus hat wird entfernt, falls keine den Focus
		// hat, wird die letzte geloescht
		if (e.getSource() == verticalButtonPanel.getDeleteButt()
				& exchangeTable.getRowCount() > 0) {
			// Editieren ggf. stoppen
			exchangeTable.stopCellEditing();

			if (exchangeTable.getRowCount() > row)
				exchangeTable.getModel().removeRow(row);
		}
		// neue Zeile einfuegen, nicht leer lassen!
		if (e.getSource() == verticalButtonPanel.getNewButt()) {
			Object[] o = new Object[1];
			exchangeTable.getModel().addRow(o);
		}

		if (e.getSource() == verticalButtonPanel.getChangeButt()) {
			exchangeTable.selectTextInCell();
		}

		if (e.getSource() == aktivCB) {
			exchangeTable.setEnabled(aktivCB.isSelected());
			verticalButtonPanel.enableButtons(aktivCB.isSelected());
			config.saveEntry("ACTIVATE_TABLE",
					new Boolean(aktivCB.isSelected()).toString());
		}

		if (e.getSource() == startCB) {
			config.saveEntry("USE_TABLE_WHILE_STARTING", new Boolean(startCB
					.isSelected()).toString());
		}
	}
}
